
angular.module('kantree').component('optionsWidgetEmailTemplate', {
  template: `
    <options-widget-select-ref ng-model="$ctrl.value" ng-change="$ctrl.ngModel.$setViewValue($ctrl.value)"
      items="$ctrl.items" is-required="$ctrl.isRequired" is-disabled="$ctrl.isDisabled"></options-widget-select-ref>
  `,
  bindings: {
    options: '<',
    isRequired: '<?',
    isDisabled: '<?'
  },
  require: {ngModel: '?ngModel'},
  controller: class extends AngularClass {
    static get $inject() {
      return ['$scope', 'emailing_templatesService', 'translation'];
    }
    $onInit() {
      this.items = [];

      this.ngModel.$render = () => {
        this.value = this.ngModel.$viewValue || null;
      };
      this.ngModel.$viewChangeListeners.push(() => {
        this.value = this.ngModel.$viewValue;
      });

      if (this.options.project) {
        this.$emailing_templatesService.list_email_templates(this.options.project.id).get((templates) => {
          this.items = templates.map(tpl => [tpl.id, tpl.name, this.$translation._('Email templates')]);
        });
      }
    }
  }
});
