
angular.module('kantree').run([
  'fileProviders', 'translation', 'config',
  function(fileProviders, translation, config) {
    $('<script type="text/javascript" src="https://www.dropbox.com/static/api/2/dropins.js" id="dropboxjs" data-app-key="' +
      config.dropbox_app_key + '"></script>').appendTo('head');

    fileProviders.push(function() {
      return [{
        label: translation._('Attach from Dropbox'),
        execute: [
          'finishCallback', 'progressCallback',
          function(finishCallback, progressCallback) {
            Dropbox.choose({
              multiselect: true,
              folderselect: false,
              success: function(files) {
                finishCallback(files.map(function(file) {
                  return {
                    name: file.name,
                    url: file.link
                  };
                }));
              }
            });
          }
        ]
      }];
    });
  }
]);
