
angular.module('ng.popperModifier', []).service('popperModifier', class extends AngularClass {
  get maxHeight() {
    return {
      name: 'maxHeight',
      enabled: true,
      phase: 'main',
      requiresIfExists: ['offset', 'preventOverflow', 'flip'],
      fn({ state, name, options }) {
        // Over simplified version of PopperMaxSizeModifier that do not take overflow, preventOverflow nor placement into account
        // Will need to be improved for full use for all Kantree dropdowns
        state.modifiersData[name] = {
          height: state.scrollParents.popper[state.scrollParents.popper.length - 1].getBoundingClientRect().height
        };
      },
    };
  }

  get applyMaxHeight() {
    return {
      name: 'applyMaxHeight',
      enabled: true,
      phase: 'beforeWrite',
      requires: ['maxHeight'],
      fn({state}) {
        // The `maxHeight` modifier provides this data
        const {height} = state.modifiersData.maxHeight;

        state.styles.popper = {
          ...state.styles.popper,
          maxHeight: `${Math.max(200, height)}px`
        };
      }
    };
  }
});
