
angular.module('ngDigicoop').directive('autoDropPosition', [
  '$window', 'optimizedWindowResize',
  function($window, optimizedWindowResize) {
    return {
      restrict: 'A',
      link: function(scope, $element, attr) {
        var $parent = $element.parent();

        var positionManagerOpts = {
          element: $element[0]
        };

        // Ugly specific code in generic directive, but this directive shouldnt stay long
        // new drop component expected soon.

        if ($element.parents('.board-viewport').length) {
          positionManagerOpts.container = '.board-viewport';
        } else if ($element.parents('.board').length) {
          positionManagerOpts.container = '.board';
        }

        if ($element.hasClass('dropdown-menu')) {
          if ($parent.hasClass('dropdown-submenu') || $parent.hasClass('dropdown')) {
            positionManagerOpts.anchor = {
              element: $element.parent()[0]
            };
            positionManagerOpts.hook = {
              x: $element.hasClass('dropdown-menu-right') ? 'right': 'left',
              y: 'top'
            };
          }

          if ($parent.hasClass('dropdown-submenu')) {
            positionManagerOpts.anchor.hook = {
              x: $element.hasClass('dropdown-menu-right') ? 'left': 'right',
              y: 'top',
            };
          } else if ($parent.hasClass('dropdown')) {
            positionManagerOpts.anchor.hook = {
              x: $element.hasClass('dropdown-menu-right') ? 'right': 'left',
              y: 'bottom',
            };
          }
        }

        var positionManager = new DropPositionManager(positionManagerOpts);

        var dropPositionSimpleRefresh = function() {
          positionManager.refresh();
        };

        // trigger positionning with angular event
        $parent.on('show.kt.contextmenu', function(event, originalEvent) {
          positionManager.refresh({
            x: originalEvent.pageX,
            y: originalEvent.pageY
          });
        });

        // bootstrap dropdown event
        if ($element.hasClass('dropdown-menu')) {

          if ($parent.hasClass('dropdown-submenu')) {

            $parent.on('shown.bs.submenu', function(event, data) {
              positionManager.refresh();
              optimizedWindowResize.add(dropPositionSimpleRefresh);
            });

            $parent.on('hide.bs.submenu', function() {
              optimizedWindowResize.remove(dropPositionSimpleRefresh);
            });

          } else if ($parent.hasClass('dropdown')) {

            $parent.on('shown.bs.dropdown', function(event, data) {
              positionManager.refresh();
              optimizedWindowResize.add(dropPositionSimpleRefresh);
            });

            $parent.on('hidden.bs.dropdown', function() {
              optimizedWindowResize.remove(dropPositionSimpleRefresh);
            });

          }

        }

        $element.on('refresh.autoDropPosition', dropPositionSimpleRefresh);

        scope.$on('$destroy', function() {
          $parent.off('show.kt.contextmenu');
          $parent.off('hide.kt.contextmenu');
          $parent.off('shown.bs.dropdown');
          $parent.off('hidden.bs.dropdown');
          $parent.off('show.bs.submenu');
          $parent.off('hide.bs.submenu');
        });
      }
    };
  }
]);
