
angular.module('ngDigicoop').component('checkboxToggle', {
  template: `
    <input type="checkbox" data-toggle="toggle" data-size="small" ng-disabled="$ctrl.disabled">
  `,
  bindings: {
    checked: '<',
    onLabel: '@',
    offLabel: '@',
    onChange: '&',
    disabled: '<?'
  },
  controller: class extends AngularClass {
    static get $inject() {
      return ['$element', '$rootScope'];
    }
    $onChanges(changes) {
      if (changes.checked && this.checkbox) {
        this.checkbox[0].checked = changes.checked.currentValue;
      }
    }
    $postLink() {
      this.checkbox = this.$element.find('input');
      this.checkbox[0].checked = this.checked;
      this.checkbox.bootstrapToggle({
        on: this.onLabel,
        off: this.offLabel
      }).change(() => {
        this.$rootScope.$applyAsync(() => this.onChange({$checked: this.checkbox[0].checked}));
      });
    }
  }
});
