
angular.module('ngDigicoop').directive('dynamicDirective', [
  '$compile', '$timeout',
  function($compile, $timeout) {
    return {
      link: function(scope, el, attrs) {
        var childScope;

        var denormalized = function(attr) {
          return attr.replace(/[A-Z]/g, function(c) {
            return '-' + c.toLowerCase();
          });
        };

        scope.$watch(function() {
          return attrs.directive;
        }, function(directive) {
          if (childScope) {
            childScope.$destroy();
          }
          if (!directive) {
            el.empty();
            return;
          }
          var html = '<' + directive;
          angular.forEach(attrs, function(value, key) {
            if (key !== 'directive' && key[0] !== '$') {
              html += ' ' + denormalized(key) + '="' + value + '"';
            }
          });
          html += '></' + directive.split(' ')[0] + '>';
          childScope = scope.$new();

          var newEl = $(html);
          el.replaceWith(newEl);
          newEl = $compile(newEl)(childScope);
          el = newEl;
        });
        scope.$on('$destroy', function() {
          if (childScope) {
            childScope.$destroy();
          }
        });
      }
    }
  }
]);
