
angular.module('ngDigicoop').filter('textColor', [
  function () {
    return function(input, light, dark, undefinedColor) {
      if (!input) {
        return undefinedColor || dark || '#000000';
      }
      return tinycolor.mostReadable(input, [light || '#FFFFFF', dark || '#000000']).toString();
    };
  }
]);

angular.module('ngDigicoop').filter('darkenColor', [
  function () {
    return function(input, value) {
      return tinycolor(input).darken(value).toString();
    };
  }
]);

angular.module('ngDigicoop').filter('lightenColor', [
  function () {
    return function(input, value) {
      return tinycolor(input).lighten(value).toString();
    };
  }
]);

angular.module('ngDigicoop').filter('slightlyDifferentColor', [
  function () {
    return function(input, value) {
      if (!input || input === '') return null;
      if (tinycolor.mostReadable(input, ['#000000', '#ffffff']).toString() === '#000000') {
        return tinycolor('#000').setAlpha(value || 0.1).toRgbString();
      } else {
        return tinycolor('#fff').setAlpha(value || 0.1).toRgbString();
      }
    };
  }
]);

angular.module('ngDigicoop').filter('isReadable', [
  function () {
    return function(input, value) {
      return tinycolor.isReadable(input, value);
    };
  }
]);
