
export class TooltipDrop {
  constructor(view) {
    this.view = view;
    this.bindedDestroy = this.destroy.bind(this);
    this.view.props.on.editorDestroy.add(this.bindedDestroy);
  }

  close() {
    this.drop && this.drop.isOpened() && this.drop.close();
  }

  destroy() {
    this.view.props.on.editorDestroy.remove(this.bindedDestroy);
    this.close();
    this.drop && this.drop.drop && this.drop.destroy();
    this.drop = null;
    return true;
  }

  isOpened() {
    return this.drop && this.drop.isOpened();
  }

  open(content, coord) {
    var self = this;
    let wrapperCoord = this.view.dom.getBoundingClientRect();
    let newCoord = {
      left: coord.left - wrapperCoord.left,
      top: coord.top - wrapperCoord.top
    };

    this.drop = new Drop({
      target: this.view.dom,
      content: content,
      classes: 'drop-theme-prosemirror tooltip-theme-prosemirror',
      constrainToScrollParent: false,
      openOn: null,
      remove: true,
      tetherOptions: {
        targetAttachment: 'top left',
        attachment: 'top left',
        targetOffset: newCoord.top + 'px ' + newCoord.left + 'px',
        constraints: [
          {
            to: 'window',
            attachment: 'element',
            pin: true
          }
        ]
      }
    });

    function stopEvent(e) {
      e.preventDefault();
      e.stopPropagation();
    }

    this.drop.on('open', function() {
      self.drop.drop && self.drop.drop.addEventListener('mousedown', stopEvent);
    });

    this.drop.on('close', function() {
      self.drop.drop && self.drop.drop.removeEventListener('mousedown', stopEvent);
    });

    this.drop.open();
  }
}
